#include <stdio.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>


#define MAXESTADOS 2
#define MAXTERMINAIS 3
#define MAXCIRCUITOS 100
#define MAXAGULHAS

#define CDV 0
#define AGU 1
#define SIG 2

#define NONE -1
 
#define DT 0
#define DV 1
#define OC 1
#define LV 0
#define PS 2
#define PD 4
#define BL 8 


enum  {
  C1_AM=1,C2_AM,C3_AM,C4_AM,C5_AM,C6_AM,C7_AM,C8_AM,C9_AM,C10_AM,C12_AM,C11_AM,C13_AM,
  M1_AM,M3_AM,S5_AM,M4_AM,M6_AM,M8_AM,M10_AM,A1_AM,A2_AM,A4_AM,
  C1_OR,C3_OR,C5_OR,C7_OR,C9_OR,C11_OR,C13_OR,C15_OR,C2_OR,C4_OR,C6_OR,C8_OR,C10_OR,C12_OR,
  C14_OR,C16_OR,M3_OR,M5_OR,M7_OR,M9_OR,M11_OR,M8_OR,M10_OR,M12_OR,S14_OR,
  A2_OR,A1_OR,A3_OR,A7_OR
};


struct tipo_circuito{
  char nome[10];
  int tipo;
  unsigned estado;
  int itenerario;
  long int timer;
} circuito[]={
  {"N", CDV, LV, 0, 25},
  {"C1_AM", CDV, OC, 0, 25},
  {"C2_AM", CDV, LV, 0, 25},
  {"C3_AM", CDV, LV, 0, 25},
  {"C4_AM", CDV, LV, 0, 25},
  {"C5_AM", CDV, LV, 0, 25},
  {"C6_AM", CDV, OC, 0, 25},
  {"C7_AM", CDV, LV, 0, 25},
  {"C8_AM", CDV, LV, 0, 25},
  {"C9_AM", CDV, LV, 0, 25},
  {"C10_AM",CDV, LV, 0, 25},
  {"C12_AM",CDV, OC, 0, 25},
  {"C11_AM",CDV, LV, 0, 25},
  {"C13_AM",CDV, LV, 0, 50},
  //  {"C15_AM",CDV, LV, 0, 25},
  {"M1_AM", SIG, PD, 0, 25},
  {"M3_AM", SIG, PD, 0, 25},
  {"S5_AM", SIG, PD, 0, 25},
  {"M4_AM", SIG, PD, 0, 25},
  {"M6_AM", SIG, PD, 0, 25},
  {"M8_AM", SIG, PD, 0, 25},
  {"M10_AM", SIG, PD, 0, 25},
  {"A1_AM", AGU, DT, 0, 0},
  {"A2_AM", AGU, DT, 0, 0},
  {"A4_AM", AGU, DT, 0, 0},
  {"C1_OR",CDV, LV, 0, 50},
  {"C3_OR",CDV, LV, 0, 25},
  {"C5_OR",CDV, OC, 0, 25},
  {"C7_OR",CDV, LV, 0, 25},
  {"C9_OR",CDV, LV, 0, 25},
  {"C11_OR",CDV, LV, 0, 25},
  {"C13_OR",CDV, LV, 0, 25},
  {"C15_OR",CDV, LV, 0, 25},
  {"C2_OR",CDV, LV, 0, 25},
  {"C4_OR",CDV, LV, 0, 25},
  {"C6_OR",CDV, LV, 0, 25},
  {"C8_OR",CDV, LV, 0, 25}, 
  {"C10_OR",CDV, LV, 0, 25},
  {"C12_OR",CDV, OC, 0, 25},
  {"C14_OR",CDV, LV, 0, 50},
  {"C16_OR",CDV, LV, 0, 50},
  {"M3_OR", SIG, PD, 0, 25},
  {"M5_OR", SIG, PD, 0, 25},
  {"M7_OR", SIG, PD, 0, 25},
  {"M9_OR", SIG, PD, 0, 25},
  {"M11_OR", SIG, PD, 0, 25},
  {"M8_OR", SIG, PD, 0, 25},
  {"M10_OR", SIG, PD, 0, 25},
  {"M12_OR", SIG, PD, 0, 25},
  {"S14_OR", SIG, PD, 0, 25},
  {"A2_OR", AGU, DT, 0, 0},
  {"A1_OR", AGU, DT, 0, 0},
  {"A3_OR", AGU, DT, 0, 0},
  {"A7_OR", AGU, DT, 0, 0}
};
#define MAXCIR A7_OR

enum { I1_AM=1, I2_AM, I3_AM, I4_AM, I5, I6, I7, I8, I1_OR, I2_OR};

struct tipo_itenerario{
  char nome[10];
  int estado;
  int origem;
  int circuito[10];
  int agulhas[5];
  int est_agulhas[5];
  int incomp[5];
  int overlap[2];
}  itenerario[]={
  {"IN", 0, 0, {0,0,0,0,0,0,0,0,0,0}, {0,0,0,0,0}, {0,0,0,0,0}, {0,0,0,0,0},{0,0}},
  {"I1_AM", 0, C6_AM, {M8_AM,C8_AM,C7_AM,C5_AM,C3_AM,C1_AM,0,0,0,0}, {A4_AM,A2_AM,0,0,0}, {DT,DV,0,0,0}, {I2_AM,I3_AM,I4_AM,0,0},{0,0}},
  {"I2_AM", 0, C1_AM, {M1_AM,C3_AM,C5_AM,C7_AM,C9_AM,0,0,0,0,0}, {A4_AM,A2_AM,0,0,0}, {DT,DT,0,0,0}, {I1_AM,I4_AM,0,0,0},{C11_AM,0}},
  {"I3_AM", 0, C6_AM, {M8_AM,C8_AM,C10_AM,C12_AM,0,0,0,0,0,0}, {A2_AM,A4_AM,0,0,0}, {DT,DT,0,0,0}, {I4_AM,I1_AM,0,0,0},{0,0}},
  {"I4_AM", 0, C12_AM,{M10_AM,C10_AM,C5_AM,C7_AM,C9_AM,0,0,0,0,0}, {A2_AM,A4_AM,0,0,0}, {DT,DV,0,0,0}, {I1_AM,I2_AM,I3_AM,0,0},{C11_AM,0}},
  {"I5", 0, C9_AM, {S5_AM,C11_AM,C13_AM,C1_OR,0,0,0,0,0}, {0,0,0,0,0}, {0,0,0,0,0}, {0,0,0,0,0},{C3_OR,0}},
  {"I6", 0, C12_OR, {S14_OR,C14_OR,C16_OR,C2_AM,0,0,0,0,0,0}, {0,0,0,0,0}, {0,0,0,0,0}, {0,0,0,0,0},{C4_AM,0}},
  {"I7", 0, C1_OR, {M3_OR,C3_OR,C5_OR,0,0,0,0,0,0,0}, {0,0,0,0,0}, {0,0,0,0,0}, {0,0,0,0,0},{C7_OR,0}},
  {"I8", 0, C2_AM, {M4_AM,C4_AM,C6_AM,0,0,0,0,0,0,0}, {0,0,0,0,0}, {0,0,0,0,0}, {0,0,0,0,0},{C8_AM,0}},
  {"I1_OR", 0, C5_OR, {M7_OR,C7_OR,C10_OR,C8_OR,C6_OR,0,0,0,0,0}, {A1_OR,A3_OR,0,0,0}, {DV,DT,0,0,0}, {I2_OR,0,0,0,0},{0,0}},
  {"I2_OR", 0, C6_OR, {M10_OR,C8_OR,C10_OR,C12_OR,0,0,0,0,0,0}, {A1_OR,A3_OR,0,0,0}, {DT,DT,0,0,0}, {I1_OR,0,0,0,0},{C14_OR,0}},
  };
#define MAXIT I2_OR
#define MAXOVER 2

struct tipo_comboio {
  char nome[20];
  int numero;
  int curr_circ;
  int curr_iten;
  int curr_node;
  long int timer;
} cb[]={
  {"0", 0, 0, 0, 0, 0},
  {"CB1", 1, C1_AM, 0, 0, 25},
  {"CB2", 2, C12_AM, 0, 0, 25},
  {"CB3", 3, C5_OR, 0, 0, 25},
  {"CB4", 4, C12_OR, 0, 0, 25},
  {"CB5", 5, C6_AM, 0, 0, 25}

};
 
#define MAXCB 5

struct tipo_automatico {
  char nome[20];
  int estado; 
  int curr_st;
  int iten[5];
} automat[]={
  {"AUT1_AL", 1, 0, {I1_AM, I2_AM,I3_AM,I4_AM,0}},
  {"PER_I5", 1, 0, {I5, I5, I5, I5, 0}},
  {"PER_I6", 1, 0, {I6, I6, I6, I6, 0}},
  {"PER_I7", 1, 0, {I7, I7, I7, I7, 0}},
  {"PER_I8", 1, 0, {I8, I8, I8, I8, 0}},
  {"AUT1_OR", 1, 0, {I1_OR, I2_OR, I1_OR, I2_OR, 0}},
};

#define MAXAUT 6

void sleep_decseg(void)
{
  static struct timespec time_ds, time_rm;
  time_ds.tv_sec=0;
  time_ds.tv_nsec=100000000;
  nanosleep(&time_ds,&time_rm);
}


void actualizar_sinalizacao(void)
{
  int i,n, cir, temp, sgn;
  int bloq_abs, bloq_simpl;
  
  // inicializa sinais no nivel de paragem absoluta //
  for(i=1; i<=MAXIT; i++)
    {
      sgn=itenerario[i].circuito[0];
      circuito[sgn].estado|=PS|PD;
  }
  // verifica se a via se encontra livre num dos itenerario //
  for(i=1; i<=MAXIT; i++)
    {
      temp=0;
      sgn=itenerario[i].circuito[temp];
      bloq_abs=0;
      while((cir=itenerario[i].circuito[++temp])>0) 
	bloq_abs|=circuito[cir].estado;
      temp=0;

      while((cir=itenerario[i].agulhas[temp])>0)
      { 
	bloq_abs|=((circuito[cir].estado==itenerario[i].est_agulhas[temp])?0:1);
	temp++;
      }
    // se via livre e itenerario construido- limpar paragem absoluta //
      if ((bloq_abs==0)&&(itenerario[i].estado==1))
	{
	  //	printf("Via livre it=%s \n", itenerario[i].nome );
	  circuito[sgn].estado&=(~PD);
	  // Se rigiao de overlap livre limpar paragem simples
	  bloq_simpl=0;
	  for(n=0; n<MAXOVER; n++)
	    bloq_simpl|=circuito[itenerario[i].overlap[n]].estado;
	  if(bloq_simpl==0) circuito[sgn].estado&=(~PS);
	}
      
      // se regiao de overlap livre limpar  //
      //      if ((bloq_abs==0)&&(itenerario[i].estado==1)) circuito[sgn].estado&=~(PD|PS);
    }
  
}

void actualizar_comboios(void)
{
  int sgn;
  int l;

  for(l=1; l<=MAXCB; l++)
    {
      if ((cb[l].timer--)<=0)
	{
  
	  if (circuito[itenerario[cb[l].curr_iten].circuito[cb[l].curr_node]].tipo==SIG)
	    sgn=circuito[itenerario[cb[l].curr_iten].circuito[cb[l].curr_node]].estado;
	  else sgn=0;
	  
	  if (sgn)
	    { /* sinal fechado, esperar pela abertura  */
	      cb[l].timer=circuito[cb[l].curr_circ].timer; 
	    }
	  
	  else
	    /* sinal aberto */
	    if (itenerario[cb[l].curr_iten].circuito[cb[l].curr_node+1]!=0)
	      {
		circuito[cb[l].curr_circ].estado=LV;
		cb[l].curr_node++;
		cb[l].curr_circ=itenerario[cb[l].curr_iten].circuito[cb[l].curr_node];
		circuito[cb[l].curr_circ].estado=OC;
		cb[l].timer=circuito[cb[l].curr_circ].timer;
		printf("Entrada cb= %s cdv=%s iten= %d  nodo=%d\n",cb[l].nome, circuito[cb[l].curr_circ].nome, cb[l].curr_iten, cb[l].curr_node);	    
		if (itenerario[cb[l].curr_iten].circuito[cb[l].curr_node+1]==0)
		  { 
		    itenerario[cb[l].curr_iten].estado=0;
		    cb[l].curr_iten=0;
		    cb[l].curr_node=0;
		  }
	      }
	      
	    else 
	      {
		//chegou ao fim do itenerario entao destruir itenerario//
		if(cb[l].curr_iten) 
		  {
		    itenerario[cb[l].curr_iten].estado=0;
		    cb[l].curr_iten=0;
		    cb[l].curr_node=0;
		  }
		
	      }
	}
    }

}

void send_sinalizacao(int fout)
{
  int i;
  char stemp[20],buf[1250]="";

  for(i=1; i<=MAXCIR; i++)
    { 
      if(circuito[i].tipo==SIG)
	switch(circuito[i].estado)
	  {
	  case 0:     
	    sprintf(stemp,"A%.3d %.1d ", i, 0);
	    break;
	  case 2:
	    sprintf(stemp,"A%.3d %.1d ", i, 1);
	    break;
	  default:
	    sprintf(stemp,"A%.3d %.1d ", i, 2);
	    break;
	  }
      else
	sprintf(stemp,"A%.3d %.1d ", i, circuito[i].estado);
      strcat(buf,stemp);
     }

  strcat(buf,"\n");
  if (write(fout,buf,strlen(buf))<0) perror("Erro na escrita da pipe2");
}

int find_train(int cir)
{
  int i;
  for(i=1;i<=MAXCB;i++)
    if(cb[i].curr_circ==cir) return i;
  return 0;
}

void atribuir_itenerarios(void)
{
  int i,tr;
  for (i=1; i<=MAXIT; i++)
    {
      if(itenerario[i].estado&&(tr=find_train(itenerario[i].origem))) 
	// se itenerario construido e existe comboio na sua origem//
	   cb[tr].curr_iten=i;
    }
}

int iten_ocupado( int iten)
{
  int cir, i=0, ocupado=0;
  while((cir=itenerario[iten].circuito[++i])>0) 
      ocupado|=circuito[cir].estado;
  return  ocupado;
}

int iten_incompativeis(int iten)
{
  int it, i=0, incomp=0;
   while((it=itenerario[iten].incomp[i++])>0) 
      incomp|=itenerario[it].estado;
   return incomp;
}

void fazer_agulhas(int iten)
{
  int ag, i=0;
   while((ag=itenerario[iten].agulhas[i])>0)
     { 
      if(circuito[ag].estado!=itenerario[iten].est_agulhas[i])
	circuito[ag].estado=itenerario[iten].est_agulhas[i];
      i++;
     }
}

void construir_itenerario(int iten)
{
  // se via livre e nao estao criados itenerario incompativeis
  if ((iten_ocupado(iten)==0)&&(iten_incompativeis(iten)==0))
      {
	fazer_agulhas(iten);
	itenerario[iten].estado=1;
      }
}

void actualizar_automaticos(void)
{

  int i, next, curr,  iten;
  for(i=0;i<MAXAUT;i++)
    if(automat[i].estado)
      {
	curr=automat[i].curr_st;
	iten=automat[i].iten[curr];
	if (find_train(itenerario[iten].origem)) 
	    construir_itenerario(iten);
	next=curr+1;
	if ((automat[i].iten[next]) > 0)
	  automat[i].curr_st=next;
	else automat[i].curr_st=0;
      }
  atribuir_itenerarios();
}

void send_cirnames(FILE *fout)
{
  int i;
  for(i=1; i<=MAXCIR; i++)
    fprintf(fout,"A%.3d %s\n",i,circuito[i].nome);
}

void send_message(int fout, const char *buf)
{
  write(fout, buf, strlen(buf));
}

void main()
{
  int fin,fout,running, err;
  int timeout=0;
  char buf[500];

  if((fin=open("pipe1", O_RDONLY | O_NONBLOCK))==-1)
     {
     perror("Erro na abertura da pipe1 de entrada! ");
     exit(1);
     }

  while(((fout=open("pipe2", O_WRONLY | O_NONBLOCK))>=-1)&&(++timeout<50)) sleep_decseg();
  if (fout<0)     
    {
     perror("Erro na abertura da pipe2 de saida! ");
     exit(1);
    }

  while(((err=read(fin,buf,1))>=-1)&&(buf[0]!='s')) sleep_decseg();
  if (err<0)     
    {
      perror("Erro na leitura da pipe1! ");
      exit(1);
    }

  actualizar_sinalizacao();
  // iniciar();
  running=1;
  while(running)
    {
      actualizar_sinalizacao();
      actualizar_automaticos();
      actualizar_comboios();
      if(read(fin,buf,1)>=0)
	switch(buf[0])
	  {
	  case 'r': send_sinalizacao(fout); break;
	  case 'q': running=0;
	  }
      else if ( errno == EAGAIN ) 
	{
	  ;
	} 
      else
	{
	  perror("Erro na leitura da pipe1! ");
	  exit(1);
	}
      sleep_decseg();
    }
  send_message(fout,"Terminando Simulador ...\n");
  close(fout);
  close(fin);
}














